<template>
  <div class="layout">
    <header>
      <div ref="menu" class="menu">
        <label class="menu_btn">
          <input type="checkbox" v-model="menuBox" />
          <img src="@/assets/img/burger.svg" />
        </label>

        <nav class="menu-list" :class="{ active: menuBox }">
          <DropdownMenu :menuData="menuData" :keyPath="keyPath" />
        </nav>
        <DropdownSelect v-model="targetKey" :menuItems="menuData" />
      </div>
    </header>
    <main>
      <RouterView />
    </main>
  </div>
</template>

<script setup lang="ts">
import type { MenuData } from '@/model/menu'
import { menuData } from './assets/mock/data'
import { useCounterStore } from '@/stores/counter'
const store = useCounterStore()

const menu = ref<HTMLInputElement | null>(null)
const menuBox = ref(false)

const targetKey = ref('')

const keyPath = computed(() => {
  return findKeyPath(menuData, targetKey.value)
})

onBeforeMount(() => {
  const itemSelect = localStorage.getItem('itemSelect')
  if (itemSelect) {
    targetKey.value = itemSelect
  }
})

onMounted(() => {
  document.addEventListener('click', function (event) {
    const target = event.target
    if (target instanceof Node) {
      const isMenuClicked = menu.value!.contains(target)

      if (!isMenuClicked) {
        menuBox.value = false
      }
    }
  })
})

watch(store, () => {
  targetKey.value = useCounterStore().selectKey
})

/**
 * 遞迴函式找key
 * @param data 要搜尋的資料
 * @param targetKey 要查詢的key
 * @param currentPath 存放遍歷的路徑
 */
function findKeyPath(
  data: MenuData[],
  targetKey: string,
  currentPath: string[] = []
): string[] | null {
  for (const item of data) {
    const newPath = [...currentPath, item.key]
    if (item.key === targetKey) {
      return newPath // 找到目標返回路徑
    }
    if (item.children) {
      const foundPath = findKeyPath(item.children, targetKey, newPath) // 遞迴查子節點
      if (foundPath) {
        return foundPath // 子節點有值返回當前路徑
      }
    }
  }
  return null
}
</script>

<style lang="scss">
* {
  box-sizing: border-box;
}
.layout {
  display: flex;
  flex-direction: column;
  min-height: 100vh;
  .menu {
    position: relative;

    & > .menu_btn {
      display: block;
      width: 30px;
      margin-left: auto;
      cursor: pointer;
      & > input {
        display: none;
      }
    }
    & > .menu-list {
      position: fixed;
      top: 0;
      right: 0;
      z-index: 999;
      height: 100vh;
      background: #000000ec;
      width: 100%;
      max-width: 300px;
      transform: translateX(100%);
      transition: transform 0.3s ease;

      &.active {
        transform: translateX(0%);
      }

      .list_box {
        display: flex;
        flex-direction: column;
        cursor: pointer;
        & > li {
          padding-left: 8.7px;
          & > div {
            padding-left: 8.7px;
            color: #fff;
            &.children {
              display: flex;
              padding-left: 0px;
              &::before {
                content: '';
                width: 0;
                height: 0;
                border-style: solid;
                border-width: 5px 0 5px 8.7px;
                border-color: transparent transparent transparent #fff;
              }
              &.select::before {
                transform: rotate(90deg);
              }
            }
            &.select {
              color: #ff0;
            }
          }
        }
      }
    }
  }

  main {
    flex: auto;
    display: flex;
    flex-direction: column;
    justify-content: flex-end;
    margin-bottom: 30px;
  }
}
</style>
